"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GithubProvider = GithubProvider;
exports["default"] = void 0;
var _functionTree = require("function-tree");
var _createRelease2 = require("./createRelease");
var _execCommand = require("../../../helpers/execCommand");
function GithubProvider(_ref) {
  var path = _ref.path,
    runCommand = _ref.runCommand;
  if (process.env.REPO_COOKER_GITHUB_TOKEN === undefined) {
    var message = "Github provider needs an OAUTH token in env REPO_COOKER_GITHUB_TOKEN.";
    if (runCommand === _execCommand.execCommand) {
      throw new Error(message);
    } else if (runCommand === _execCommand.logCommand) {
      console.warn(message);
    }
  }
  return new _functionTree.Provider({
    createRelease: function createRelease(tagName, body) {
      // Has side effects so we wrap with runCommand
      return runCommand(_createRelease2.createRelease, [path, tagName, body]);
    }
  });
}
var _default = exports["default"] = GithubProvider;
//# sourceMappingURL=index.js.map