"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCurrentPackageVersion = getCurrentPackageVersion;
var _getFromNpmRegistry = require("./getFromNpmRegistry");
// Initial temporary releases (beta, next) automatically set `latest` on npm registry
// and we must not use these temporary releases as base to compute semver.
var SEMVER_RE = /^\d+\.\d+\.\d+$/;
function getCurrentPackageVersion(packageName) {
  return (0, _getFromNpmRegistry.getFromNpmRegistry)(packageName).then(function (registryDetails) {
    var version = registryDetails && registryDetails['dist-tags'] && registryDetails['dist-tags'].latest || null;
    return version && SEMVER_RE.test(version) ? version : null;
  });
}
//# sourceMappingURL=getCurrentPackageVersion.js.map