"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFromNpmRegistry = getFromNpmRegistry;
var _axios = _interopRequireDefault(require("axios"));
var _registryUrl = _interopRequireDefault(require("registry-url"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var registryUrl = (0, _registryUrl["default"])();
var cache = {};
function getFromNpmRegistry(packageName) {
  return new Promise(function (resolve, reject) {
    if (cache[packageName]) {
      return resolve(cache[packageName]);
    }
    _axios["default"].get("".concat(registryUrl).concat(packageName.replace('/', '%2F'))).then(function (response) {
      cache[packageName] = response.data;
      resolve(cache[packageName]);
    })["catch"](function (error) {
      if (error.response && error.response.status === 404) {
        cache[packageName] = null;
        return resolve(cache[packageName]);
      } else {
        reject(new Error(error));
      }
    });
  });
}
//# sourceMappingURL=getFromNpmRegistry.js.map