"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceTag = replaceTag;
function replaceTag(config) {
  var runCommand = config.runCommand,
    packagesPaths = config.packagesPaths;
  return function replaceTag(packageName, version, fromTag, toTag) {
    var cwd = packagesPaths[packageName];
    return runCommand('npm', ['dist-tag', 'add', "".concat(packageName, "@").concat(version), toTag], {
      cwd: cwd,
      pause: true
    }).then(function () {
      return new Promise(function (resolve, reject) {
        return (
          // We accept failure for this operation (somehow this happens for no reason
          // when everything is OK).
          runCommand('npm', ['dist-tag', 'rm', packageName, fromTag], {
            cwd: cwd
          }).then(function (result) {
            return resolve(result);
          })["catch"](function (err) {
            console.log(err);
            resolve('');
          })
        );
      });
    });
  };
}
//# sourceMappingURL=replaceTag.js.map