"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runScript = runScript;
var _helpers = require("../PackageJsonProvider/helpers");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function runScript(config) {
  var runCommand = config.runCommand,
    packagesPaths = config.packagesPaths;
  return function runScript(packageName, scriptName) {
    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var cwd = packagesPaths[packageName];
    return (0, _helpers.getPackageInfo)(packageName, cwd).then(function (info) {
      return (info.scripts || {})[scriptName];
    }).then(function (exists) {
      return exists ? runCommand('npm', ['run', scriptName].concat(_toConsumableArray(args)), {
        cwd: cwd
      }).then(function (output) {
        return {
          pass: true,
          output: output
        };
      })["catch"](function (error) {
        return {
          pass: false,
          error: error
        };
      }) : false;
    });
  };
}
//# sourceMappingURL=runScript.js.map