"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRelatedPackages = getRelatedPackages;
var _helpers = require("./helpers");
function getRelatedPackages(config) {
  function getRelatedPackages(name) {
    return (0, _helpers.getPackageInfo)(name, config.packagesPaths[name]).then(function (info) {
      var dependencies = Object.assign({}, info.peerDependencies || {}, info.dependencies || {});
      return Object.keys(dependencies).reduce(function (relatedPackages, dependency) {
        if (dependency in config.packagesPaths) {
          return relatedPackages.concat(dependency);
        }
        return relatedPackages;
      }, []);
    });
  }
  return getRelatedPackages;
}
//# sourceMappingURL=getRelatedPackages.js.map