"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPackageInfo = getPackageInfo;
var _path = require("../../../helpers/path");
var _fs = require("fs");
var packageInfoCache = {};
function getPackageInfo(name, path) {
  var packagePath = (0, _path.join)(path, 'package.json');
  var cache = packageInfoCache[packagePath];
  if (cache) {
    return Promise.resolve(JSON.parse(cache));
  }
  return new Promise(function (resolve, reject) {
    return (0, _fs.readFile)(packagePath, 'utf8', function (err, data) {
      if (err) {
        reject(err);
      }
      try {
        var info = JSON.parse(data);
        if (info.name !== name) {
          reject(new Error("Invalid package.json (name entry '".concat(info.name, "' does not match package name '").concat(name, "').")));
        } else {
          packageInfoCache[packagePath] = data;
          resolve(info);
        }
      } catch (err) {
        reject(err);
      }
    });
  });
}
//# sourceMappingURL=helpers.js.map