"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.write = write;
var _fs = require("fs");
var _path = require("../../../helpers/path");
var options = {
  encoding: 'utf8'
};
function getContent(path) {
  return new Promise(function (resolve, reject) {
    (0, _fs.readFile)(path, options, function (err, data) {
      if (err) {
        reject(err);
      } else {
        resolve(JSON.parse(data));
      }
    });
  });
}
function writeFile(path, data, options) {
  return new Promise(function (resolve, reject) {
    (0, _fs.writeFile)(path, data, options || {}, function (err) {
      return err ? reject(err) : resolve();
    });
  });
}
function write(_ref) {
  var runCommand = _ref.runCommand,
    packagesPaths = _ref.packagesPaths;
  return function write(packageName, newContentCb) {
    var path = (0, _path.join)(packagesPaths[packageName], 'package.json');
    return getContent(path).then(function (content) {
      return Object.assign({}, content, newContentCb(content));
    }).then(function (newContent) {
      return runCommand(writeFile, [path, JSON.stringify(newContent, null, 2), options]);
    });
  };
}
//# sourceMappingURL=write.js.map