"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCurrentPackageVersion = getCurrentPackageVersion;
var _axios = _interopRequireDefault(require("axios"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var RE = /<title>.*v([0-9.]+)<\/title>/;
var BADGES_URL = 'https://vsmarketplacebadge.apphb.com/version-short';
var cache = {};
function getCurrentPackageVersion(name, packageJson) {
  return new Promise(function (resolve, reject) {
    if (cache[name] !== undefined) {
      return resolve(cache[name]);
    }
    var url = "".concat(BADGES_URL, "/").concat(packageJson.publisher, ".").concat(packageJson.name, ".svg");
    _axios["default"].get(url).then(function (response) {
      var re = RE.exec(response.data);
      if (!re) {
        return reject(new Error("Could not scrape url '".concat(url, "' for vscode extension version.")));
      }
      cache[name] = re[1];
      resolve(cache[name]);
    })["catch"](function (error) {
      if (error.response && error.response.status === 404) {
        cache[name] = null;
        return resolve(cache[name]);
      } else {
        reject(new Error(error));
      }
    });
  });
}
//# sourceMappingURL=getCurrentPackageVersion.js.map