"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.build = build;
var _runAll = require("../helpers/runAll");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function buildPackages(npm, names) {
  return (0, _runAll.runAll)(names.map(function (name) {
    return npm.runScript(name, 'build');
  })).then(function (results) {
    var failures = results.filter(function (result) {
      return result && !result.pass;
    });
    if (failures.length) {
      throw new Error("running npm scripts 'build' failed.");
    }
    return Object.assign.apply(Object, _toConsumableArray(results.map(function (result, idx) {
      return _defineProperty({}, names[idx], result || false);
    })));
  });
}
function build(_ref2) {
  var props = _ref2.props,
    npm = _ref2.npm;
  var related = props.relatedPackagesByPackage;
  var built = {};
  function buildReady(todo) {
    if (!todo.length) {
      return Promise.resolve({});
    }
    var ready = todo.filter(function (name) {
      return related[name].filter(function (n) {
        return built[n] === undefined;
      }).length === 0;
    });
    if (!ready.length) {
      return Promise.reject(new Error("Cannot build packages: there is a dependency cycle between packages ".concat(JSON.stringify(related), ".")));
    }
    return buildPackages(npm, ready).then(function (results) {
      Object.assign(built, results);
      return buildReady(todo.filter(function (n) {
        return built[n] === undefined;
      }));
    });
  }
  return buildReady(Object.keys(related)).then(function () {
    return {
      build: built
    };
  });
}
//# sourceMappingURL=build.js.map