"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.byReleaseTarget = byReleaseTarget;
var TO_RE = /^--release-to=(.+)$/;
var DEFAULT_GIT_HOST = 'github';
function byReleaseTarget(_ref) {
  var path = _ref.path,
    props = _ref.props;
  var gitHost = DEFAULT_GIT_HOST;
  var arg = props.argv.find(function (arg) {
    return TO_RE.exec(arg);
  });
  if (arg) {
    gitHost = TO_RE.exec(arg)[1];
  }
  if (path[gitHost]) {
    return path[gitHost]();
  } else {
    throw new Error("Cannot release to '".concat(gitHost, "' (can only release to ").concat(Object.keys(path).join(', '), ")."));
  }
}
//# sourceMappingURL=byReleaseTarget.js.map