"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createReleaseNotes = createReleaseNotes;
var builtinTemplates = _interopRequireWildcard(require("./releaseNotes"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function groupCommitsByType(commits) {
  if (!commits) {
    return {};
  }
  var groups = {};
  var _iterator = _createForOfIteratorHelper(commits),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var commit = _step.value;
      if (!groups[commit.type]) {
        groups[commit.type] = [];
      }
      groups[commit.type].push(commit);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.keys(groups).sort().map(function (k) {
    return _defineProperty({}, k, groups[k]);
  }))));
}
function summarizeRelease(_ref2) {
  var commits = _ref2.commits,
    commitsByPackage = _ref2.commitsByPackage,
    commitsWithoutPackage = _ref2.commitsWithoutPackage,
    newVersionByPackage = _ref2.newVersionByPackage,
    currentVersionByPackage = _ref2.currentVersionByPackage,
    tag = _ref2.tag;
  var summary = {};
  Object.keys(commitsByPackage).forEach(function (name) {
    var commitsByType = {};
    function insertCommit(type, commit) {
      if (summary[type] === undefined) {
        summary[type] = [];
      }
      if (commitsByType[type] === undefined) {
        commitsByType[type] = {
          name: name,
          version: newVersionByPackage[name],
          commits: []
        };
        summary[type].push(commitsByType[type]);
      }
      commitsByType[type].commits.push(commit);
    }
    commitsByPackage[name].forEach(function (commit) {
      insertCommit(commit.type, commit);
    });
  });
  return {
    tag: tag,
    newVersionByPackage: newVersionByPackage,
    currentVersionByPackage: currentVersionByPackage,
    commitsWithoutPackage: commitsWithoutPackage,
    commits: commits,
    commitsByType: groupCommitsByType(commits),
    summary: Object.keys(summary).sort().reduce(function (acc, key) {
      acc[key] = summary[key];
      return acc;
    }, {})
  };
}
function createReleaseNotes(templateArg) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var template;
  if (typeof templateArg === 'string') {
    template = builtinTemplates[templateArg];
    if (!template) {
      throw new Error("Unknown builtin template '".concat(templateArg, "' (not one of ").concat(Object.keys(builtinTemplates).join(', ')));
    }
  } else {
    template = templateArg;
  }
  return function createReleaseNotes(_ref3) {
    var props = _ref3.props;
    var releaseNotes = props.commits ? template(summarizeRelease(props), options).replace(/\n\n[\n]+/g, '\n\n') : '';
    if (props.argv.includes('--print-release')) {
      console.log(releaseNotes);
    }
    return {
      releaseNotes: releaseNotes
    };
  };
}
//# sourceMappingURL=createReleaseNotes.js.map