"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRawCommitsFromHistory = getRawCommitsFromHistory;
var _runAll = require("../helpers/runAll");
function getRawCommitsFromHistory(_ref) {
  var props = _ref.props,
    git = _ref.git;
  return (0, _runAll.runAll)(props.history.map(function (hash) {
    return git.getCommit(hash);
  })).then(function (rawCommits) {
    return rawCommits.sort(function (a, b) {
      return a.date < b.date ? -1 : 1;
    });
  }).then(function (rawCommits) {
    return {
      rawCommits: rawCommits
    };
  });
}
//# sourceMappingURL=getRawCommitsFromHistory.js.map