"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.backwardGraph = backwardGraph;
exports.forwardGraph = forwardGraph;
exports.fs = void 0;
var _fs = require("fs");
function forwardGraph(dependencies, names) {
  var seen = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  names.forEach(function (name) {
    if (!seen[name]) {
      seen[name] = true;
      forwardGraph(dependencies, dependencies[name] || [], seen);
    }
  });
  return seen;
}
function backwardGraph(dependencies, names) {
  var seen = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  names.forEach(function (name) {
    if (!seen[name]) {
      seen[name] = true;
      var dependent = Object.keys(dependencies).filter(function (packageName) {
        return (
          // Packages that depend on 'name'
          dependencies[packageName].includes(name)
        );
      });
      backwardGraph(dependencies, dependent, seen);
    }
  });
  return seen;
}

// We use this helper so that we can mock during testing.
var fs = exports.fs = {
  readFileSync: function readFileSync() {
    return _fs.readFileSync.apply(void 0, arguments);
  },
  writeFileSync: function writeFileSync() {
    return _fs.writeFileSync.apply(void 0, arguments);
  }
};
//# sourceMappingURL=helpers.js.map