"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.linkAsModule = linkAsModule;
var _fs = require("fs");
var _path = require("path");
var _promises = require("fs/promises");
var _path2 = require("../helpers/path");
var _runAll = require("../helpers/runAll");
var _symlinkDir = _interopRequireDefault(require("symlink-dir"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
// Alias to show 'linkAsModule'
var linkOne = function linkAsModule(sourcePackage, pkgAsModule) {
  return new Promise(function (resolve, reject) {
    var dir = (0, _path.dirname)(pkgAsModule);
    if (!(0, _fs.existsSync)(dir)) {
      (0, _fs.mkdirSync)(dir, {
        recursive: true
      });
    }
    (0, _symlinkDir["default"])(sourcePackage, pkgAsModule).then(function () {
      resolve(true);
    }, function (err) {
      console.warn("Cannot create symlink '".concat(pkgAsModule, "' (there is a directory there probably)."));
      reject(err);
    });
  });
};
function linkAsModule(_ref) {
  var config = _ref.config;
  var runCommand = config.runCommand;
  var packages = Object.keys(config.packagesPaths);
  var packagesPaths = packages.map(function (k) {
    return (0, _path2.resolve)(config.packagesPaths[k]).slice(0, -k.length - 1);
  });
  var commonPath = packagesPaths[0];
  while (packagesPaths.find(function (p) {
    return !p.startsWith(commonPath);
  })) {
    commonPath = (0, _path.dirname)(commonPath);
  }
  if (commonPath.includes('node_modules')) {
    // packages are stored in a folder called node_modules: no link needed
    return {
      linkAsModule: {}
    };
  }
  var nodeModules = (0, _path2.resolve)(commonPath, 'node_modules');
  if (!(0, _fs.existsSync)(nodeModules)) {
    runCommand(_promises.mkdir, [nodeModules, {
      recursive: true
    }]);
  }
  return (0, _runAll.runAll)(packages.map(function (name) {
    return runCommand(linkOne, [config.packagesPaths[name], (0, _path2.resolve)(nodeModules, name)]);
  })).then(function (results) {
    return _defineProperty({}, "linkAsModule", Object.assign.apply(Object, [{}].concat(_toConsumableArray(results.map(function (result, idx) {
      return _defineProperty({}, packages[idx], result);
    })))));
  });
}
//# sourceMappingURL=linkAsModule.js.map