"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.publishUnderTemporaryNpmTag = publishUnderTemporaryNpmTag;
var _runAll = require("../helpers/runAll");
function publishUnderTemporaryNpmTag(_ref) {
  var config = _ref.config,
    npm = _ref.npm,
    packageJson = _ref.packageJson,
    props = _ref.props;
  var packages = Object.keys(props.newVersionByPackage).filter(function (name) {
    return props.newVersionByPackage[name] !== props.currentVersionByPackage[name];
  });

  // Need to ensure successful release of all packages, so
  // we publish under a temporary tag first
  return (0, _runAll.runAll)(packages.map(function (name) {
    return packageJson.get(name).then(function (info) {
      return info["private"] ? null : name;
    });
  })).then(function (names) {
    return names.filter(function (name) {
      return name !== null;
    });
  }).then(function (names) {
    return (0, _runAll.runAll)(names.map(function (name) {
      return npm.publish(name, 'releasing');
    })).then(function () {
      return {
        temporaryNpmTagByPackage: names.reduce(function (temporaryNpmTagByPackage, name) {
          temporaryNpmTagByPackage[name] = 'releasing';
          return temporaryNpmTagByPackage;
        }, {})
      };
    }).then(function (arg) {
      return config.dryRun ? arg : new Promise(function (resolve) {
        return setTimeout(function () {
          return resolve(arg);
        }, 3000);
      });
    });
  });
}
//# sourceMappingURL=publishUnderTemporaryNpmTag.js.map