"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.relatedPackagesByPackage = relatedPackagesByPackage;
var _runAll = require("../helpers/runAll");
/*
  For each package, return a list of related packages on which this
  package depends.
*/
function relatedPackagesByPackage(_ref) {
  var config = _ref.config,
    packageJson = _ref.packageJson,
    props = _ref.props;
  var allPackageNames = Object.keys(config.packagesPaths);
  return (0, _runAll.runAll)(allPackageNames.map(function (name) {
    return packageJson.getRelatedPackages(name);
  })).then(function (allRelatedPackages) {
    return allPackageNames.reduce(function (dependsOn, packageName, index) {
      dependsOn[packageName] = allRelatedPackages[index];
      return dependsOn;
    }, {});
  }).then(function (relatedPackagesByPackage) {
    return {
      relatedPackagesByPackage: relatedPackagesByPackage
    };
  });
}
//# sourceMappingURL=relatedPackagesByPackage.js.map