"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.simpleNotes = simpleNotes;
function showCommit(commit) {
  return "\n  - ".concat(commit.summary, " ").concat(commit.issues.length ? '(' + commit.issues.join(', ') + ')' : '', " - *").concat(commit.author.name, "*\n    ").concat(commit.breaks.map(function (breakInfo) {
    return "- ".concat(breakInfo);
  }).join('\n'), "\n");
}
function showPackageSummary(packageSummary) {
  return "\n#### ".concat(packageSummary.name, " - ").concat(packageSummary.version, "\n  ").concat(packageSummary.commits.map(showCommit).join('\n'), "\n");
}
function writeBreaks(breaks) {
  if (!breaks) {
    return '';
  }
  return "\n## ".concat(breaks.length, " breaking\n").concat(breaks.map(showPackageSummary).join('\n'), "\n---\n");
}
function writeFixes(fix) {
  if (!fix) {
    return '';
  }
  return "\n## ".concat(fix.length, " ").concat(fix.length === 1 ? 'fix' : 'fixes', "\n").concat(fix.map(showPackageSummary).join('\n'), "\n---\n");
}
function writeFeat(feat) {
  if (!feat) {
    return '';
  }
  return "\n## ".concat(feat.length, " ").concat(feat.length === 1 ? 'feature' : 'features', "\n").concat(feat.map(showPackageSummary).join('\n'), "\n---\n");
}
function simpleNotes(release) {
  return "".concat(writeBreaks(release.summary.breaks), "\n").concat(writeFixes(release.summary.fix), "\n").concat(writeFeat(release.summary.feat), "\n");
}
//# sourceMappingURL=simple.js.map