"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runNpmScript = runNpmScript;
var _runAll = require("../helpers/runAll");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function runNpmScript(scriptNameTag) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var providedPackageNames = arguments.length > 2 ? arguments[2] : undefined;
  return function runNpmScript(_ref) {
    var config = _ref.config,
      props = _ref.props,
      npm = _ref.npm,
      resolve = _ref.resolve;
    var scriptName = resolve.value(scriptNameTag);
    var packages = providedPackageNames || Object.keys(config.packagesPaths);
    return (0, _runAll.runAll)(packages.map(function (name) {
      return npm.runScript(name, scriptName, args);
    })).then(function (results) {
      var failures = results.filter(function (result) {
        return result && !result.pass;
      });
      if (failures.length) {
        throw new Error("running npm scripts '".concat(scriptName, "' failed."));
      }
      return _defineProperty({}, "".concat(scriptName, "NpmScript"), Object.assign.apply(Object, _toConsumableArray(results.map(function (result, idx) {
        return _defineProperty({}, packages[idx], result);
      }))));
    });
  };
}
//# sourceMappingURL=runNpmScript.js.map