"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tagCurrentCommit = tagCurrentCommit;
var _getLatestReleaseHash = require("./getLatestReleaseHash");
function tagCurrentCommit(_ref) {
  var git = _ref.git;
  var date = new Date().toISOString();
  var releaseDate = date.slice(0, 16).replace('T', '_').replace(':', '');
  // This is used to detect latest release in getLatestReleaseHash
  // THIS NAME MUST MATCH RELEASE_RE
  var name = "v".concat(releaseDate);
  if (!_getLatestReleaseHash.RELEASE_RE.test(name)) {
    // This should NEVER EVER EVER happen :-)
    throw new Error("Tag '".concat(name, "' does not match ").concat(_getLatestReleaseHash.RELEASE_RE, " !!"));
  }
  return git.createTagForCommit(name).then(function () {
    return {
      tag: {
        name: name,
        date: date
      }
    };
  });
}
//# sourceMappingURL=tagCurrentCommit.js.map