"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeVersionsToPackages = writeVersionsToPackages;
var _runAll = require("../helpers/runAll");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function updateField(content, currentVersionByPackage, newVersionByPackage, name) {
  if (!content[name]) {
    return {};
  }
  var currentDeps = content[name];
  return _defineProperty({}, name, Object.keys(content[name]).reduce(function (dependencies, dependency) {
    dependencies[dependency] = dependency in newVersionByPackage ? "".concat(newVersionByPackage[dependency]) : dependency in currentVersionByPackage ? "".concat(currentVersionByPackage[dependency]) : currentDeps[dependency];
    return dependencies;
  }, {}));
}
function createWriteCallback(name, newVersionByPackage, currentVersionByPackage) {
  return function writeCallback(content) {
    var version = newVersionByPackage[name];

    /*
      If there are any dependencies, peerDependencies or devDependencies, we
      need to fill in the correct version from related packages.
    */
    return Object.assign({}, content, {
      version: version
    }, updateField(content, currentVersionByPackage, newVersionByPackage, 'dependencies'), updateField(content, currentVersionByPackage, newVersionByPackage, 'devDependencies'), updateField(content, currentVersionByPackage, newVersionByPackage, 'peerDependencies'));
  };
}
function writeVersionsToPackages(_ref2) {
  var packageJson = _ref2.packageJson,
    _ref2$props = _ref2.props,
    newVersionByPackage = _ref2$props.newVersionByPackage,
    currentVersionByPackage = _ref2$props.currentVersionByPackage;
  var packages = Object.keys(newVersionByPackage);
  return (0, _runAll.runAll)(packages.map(function (name) {
    return packageJson.write(name, createWriteCallback(name, newVersionByPackage, currentVersionByPackage));
  })).then(function () {
    return {};
  });
}
//# sourceMappingURL=writeVersionsToPackages.js.map