"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPackagesPaths = getPackagesPaths;
var _globby = _interopRequireDefault(require("globby"));
var _fs = require("fs");
var _path = require("../helpers/path");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function getPackagesPaths(cwd, glob) {
  if (!glob) {
    // single repo
    var packageName = JSON.parse((0, _fs.readFileSync)((0, _path.resolve)(cwd, 'package.json'), 'utf8')).name;
    return _defineProperty({}, packageName, (0, _path.resolve)(cwd));
  } else {
    return _globby["default"].sync(typeof glob === 'string' ? [glob] : glob, {
      cwd: cwd
    }).sort().map(function (path) {
      return (0, _path.resolve)(cwd, path);
    }).filter(function (path) {
      return (0, _fs.existsSync)((0, _path.resolve)(path, 'package.json'));
    }).reduce(function (packagesMap, path) {
      var pathArray = path.split('/');
      var packageName = pathArray.pop();
      var dir = pathArray.pop();

      // If package starts with scoped dir, use that as part of name
      packagesMap[dir[0] === '@' ? dir + '/' + packageName : packageName] = path;
      return packagesMap;
    }, {});
  }
}
//# sourceMappingURL=getPackagesPaths.js.map