"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseArgs = parseArgs;
var _sequences = require("../sequences");
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var builtinRe = /^--builtin=(.+)$/;
var releaseRe = /^--release(=(.+)|)$/;
var ALIAS = {
  '--link': '--builtin=link',
  '--link-bin': '--builtin=linkBin',
  '--build': '--builtin=build'
};
var optionRe = /^--.+$/;
var validOption = {
  '--dry-run': true,
  '--devtools': true,
  '--builtin=[cmd_name]': true,
  '--build': true,
  '--link': true,
  '--link-bin': true,
  '--print-release': true,
  '--release=[release_type]': true,
  '--release': true,
  '--no-parallel': true,
  // Only for monorepo
  '--check-dependencies': true,
  '--fix-dependencies': true
};
function parseArgs(allArgs) {
  var cmd;
  var builtin;
  var cmdArgs = [];
  var args = allArgs.slice();
  // nodeExecutable
  args.shift();
  // script
  args.shift();
  var _iterator = _createForOfIteratorHelper(args),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var arg = _step.value;
      var isBuiltin = builtinRe.exec(ALIAS[arg] || arg);
      var isRelease = releaseRe.exec(arg);
      var isOpt = optionRe.exec(arg);
      if (arg === '--check-dependencies' || arg === '--fix-dependencies') {
        builtin = _sequences.builtinSequences.checkDependencies;
        cmdArgs.push(arg);
      } else if (isRelease) {
        var type = isRelease[2];
        var sequence = "".concat(type || 'default', "Release");
        builtin = _sequences.builtinSequences[sequence];
        if (!builtin) {
          throw new Error("Invalid option '".concat(arg, "' (unknown builtin sequence '").concat(sequence, "')."));
        }
        cmdArgs.push(arg);
      } else if (isBuiltin) {
        var _sequence = isBuiltin[1];
        builtin = _sequences.builtinSequences[_sequence];
        if (!builtin) {
          throw new Error("Invalid option '".concat(arg, "' (unknown builtin sequence '").concat(_sequence, "')."));
        }
        cmdArgs.push(arg);
      } else if (isOpt) {
        // option
        if (!validOption[arg]) {
          throw new Error("Invalid option '".concat(arg, "'. Known options are (").concat(Object.keys(validOption).join(', '), ")."));
        }
        cmdArgs.push(arg);
      } else if (!cmd) {
        cmd = arg;
      } else {
        cmdArgs.push(arg);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return {
    cmd: cmd,
    args: cmdArgs,
    builtin: builtin
  };
}
//# sourceMappingURL=parseArgs.js.map