"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseHeader = parseHeader;
var headerRe = /^(\w+)(?:\((.+)\))?:\s*(.+)$/;
/* type(scope): message
 * type: message
 */
function parseHeader(header) {
  var match = headerRe.exec(header);
  if (!match) {
    // non-standard commit message. BAD
    return {
      type: undefined,
      scope: undefined,
      summary: header
    };
  }
  return {
    type: match[1],
    scope: match[2],
    summary: match[3].trim()
  };
}
//# sourceMappingURL=parseHeader.js.map